      MODULE s_CPODEF
      CONTAINS

C*
      SUBROUTINE CPODEF(TIME,EPSR,PSIR)
CC
CC NAME       :  CPODEF
CC
CC PURPOSE    :  DEFINITION OF CPO-COORDINATES EPSR,PSIR (RADIAN)
CC
CC PARAMETERS :
CC         IN :  TIME   : TIME OF REQUEST IN MJD (IN UTC)     R*8
CC        OUT :  EPSR   : DELTA EPS-COORDINATE (RADIAN)       R*8
CC               PSIR   : DELTA PSI-COORDINATE (RADIAN)       R*8
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  R. WEBER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  09-APR-94
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC               29-JAN-07 : AG: EXTRAPOLATION TOLERANCE FOR LITPOL ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1994     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE s_litpol
      USE s_getcpo
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      REAL*8  EPSR, PSIR, TIME, epsr_hlp(1), psi_hlp(1)
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
C
      REAL*8 T(2),DEPS(2),DPSI(2)
C
      DATA T/200000.D0,0.D0/
C
      IF (TIME.LT.T(1) .OR. TIME.GT.T(2)) THEN
        CALL GETCPO(TIME,T,DEPS,DPSI)
      END IF
C
C INTERPOLATION OF CELESTIAL POLE COORDINATES
C -------------------------------------------
      CALL LITPOL(2,1,T,DEPS,TIME,0d0,EPSR_hlp)
      EPSR = epsr_hlp(1)
      CALL LITPOL(2,1,T,DPSI,TIME,0d0,PSI_hlp)
      PSIR = psi_hlp(1)
C
      RETURN
      END SUBROUTINE

      END MODULE
