      MODULE s_CURARC
      CONTAINS

C*
      SUBROUTINE CURARC(ISAT,IFIL,ARCNUM,IARC,NUMSTD,FILNUM)
CC
CC NAME       :  CURARC
CC
CC PURPOSE    : RETRIEVE ESSENTIAL INFORMATION FROM ARRAY ARCNUM
CC              FOR SATELLITE NUMBER ISAT UP TO AND INCLUDING FILE
CC              NUMBER IFIL.
CC
CC PARAMETERS :
CC        IN  : ISAT    : SATELLITE INDEX                           I*4
CC              IFIL    : FILE NUMBER                               I*4
CC              ARCNUM  : ARRAY CONTAINING THE ARC NUMBERS FOR EACH I*4(*,*)
CC                        SATELLITE AND EACH FILE
CC        OUT : IARC    : CURRENT ARC NUMBER                        I*4
CC              NUMSTD  : NUMBER OF FILES IN ARC (UP TO FILE=IFIL)  I*4
CC              FILNUM  : CORRESPONDING FILE NUMBERS                I*4(*)
CC
CC REMARKS    :
CC
CC AUTHOR     :  G.BEUTLER
CC
CC VERSION    :  3.5  (MAY 94)
CC
CC CREATED    :  94/05/11
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC CHANGES    :  ---
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1994     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IARC  , IF    , IFIL  , ISAT  , MXCSAT, NUMSTD
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
CCC       IMPLICIT INTEGER*4 (I-N)
      COMMON/MCMSAT/MXCSAT,MXNSAT
      CHARACTER*6 MXNSAT
      INTEGER*4   ARCNUM(MXCSAT,*),FILNUM(*)
C
C LOOK FOR CURRENT ARC NUMBER
C ---------------------------
      IARC=ARCNUM(ISAT,IFIL)
      NUMSTD=0
      IF(IARC.EQ.0)GO TO 999
      DO 10 IF=1,IFIL
        IF(ARCNUM(ISAT,IF).EQ.IARC)THEN
          NUMSTD=NUMSTD+1
          FILNUM(NUMSTD)=IF
        END IF
10    CONTINUE
999   CONTINUE
      RETURN
      END SUBROUTINE

      END MODULE
