      MODULE s_DSTIME
      CONTAINS
C
      SUBROUTINE DSTIME(IYEAR,TJULB,TJULE)
C
C  COMPUTATION OF THE DAYLIGHT SAVING TIME PERIOD FOR THE YEAR 'IYEAR'
C  IN MOD.JUL.DATE (BEGIN AND END IN UTC)
C
C  VALID FOR SWITZERLAND
C
C  see http://www.metas.ch/de/labors/4/Szeit.html
C
      USE f_djul
      USE s_weekdy
C
      REAL*8 TJULB,TJULE,TJUL
C
      IF(IYEAR.EQ.1941) THEN
        TJULB=DJUL(1941,5,5.D0)
        TJULE=DJUL(1941,10,6.D0)
C
      ELSEIF(IYEAR.EQ.1942) THEN
        TJULB=DJUL(1942,5,4.D0)
        TJULE=DJUL(1942,10,5.D0)
C
      ELSEIF(IYEAR.GE.1981.AND.IYEAR.LE.1995) THEN
        TJUL=DJUL(IYEAR,4,1.D0)
        CALL WEEKDY(TJUL,IWDAY,NRWEEK,IYEARW)
        TJULB=TJUL-IWDAY+1.D0/24.D0
        TJUL=DJUL(IYEAR,10,1.D0)
        CALL WEEKDY(TJUL,IWDAY,NRWEEK,IYEARW)
        TJULE=TJUL-IWDAY+1.D0/24.D0
C
      ELSEIF(IYEAR.GE.1996) THEN
        TJUL=DJUL(IYEAR,4,1.D0)
        CALL WEEKDY(TJUL,IWDAY,NRWEEK,IYEARW)
        TJULB=TJUL-IWDAY+1.D0/24.D0
        TJUL=DJUL(IYEAR,11,1.D0)
        CALL WEEKDY(TJUL,IWDAY,NRWEEK,IYEARW)
        TJULE=TJUL-IWDAY+1.D0/24.D0
      ELSE
        TJULB=0.D0
        TJULE=0.D0
      END IF
C
      RETURN
      END SUBROUTINE
C
      END MODULE
