      MODULE f_gpsmjd
      CONTAINS

C*
      FUNCTION GPSMJD(SECOND,NWEEK)
CC
CC NAME       :  GPSMJD
CC
CC    XXX = GPSMJD(SECOND,NWEEK)
CC
CC PURPOSE    :  COMPUTE MOD. JUL. DATE IF SEC. PAST MIDNIGHT OF LAST
CC               SATURDAY/SUNDAY AND GPS WEEK NUMBER OF CURRENT
CC               DATE ARE GIVEN
CC
CC PARAMETERS :
CC        IN  :  SECOND : NUMBER OF SECONDS PAST MIDNIGHT OF LAST  R*8
CC                        WEEKEND (SATURDAY/SUNDAY)
CC               NWEEK  : GPS WEEK NUMBER OF CURRENT WEEK          I*4
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  W. GURTNER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  87/11/30 08:11
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 NWEEK
C
      REAL*8    DELTAT, GPSMJD, SECOND
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
C
C  DAYS SINCE STARTING EPOCH OF GPS WEEKS (SUNDAY 06-JAN-80)
      DELTAT=(NWEEK)*7.D0+SECOND/86400.D0
C
C  MOD. JULIAN DATE
      GPSMJD=44244.D0+DELTAT
C
      RETURN
      END FUNCTION

      END MODULE
