      MODULE s_INMAPR
      CONTAINS

C*
      SUBROUTINE INMAPR(LSTSLP,LSTDEL,LSTMXI,SLPLST,SLPXXX,IONO)
CC
CC NAME       :  INMAPR
CC
CC PURPOSE    :  INITIALIZE ARRAYS FOR AUTOMATIC AND MANUAL
CC               PREPROCESSING FOR VERSION 3.2 BERNESE GPS SOFTWARE
CC
CC PARAMETERS :
CC    IN/OUT  :  LSTSLP(K,I),K=1,..,6, I=1,2,..,MAXSLP        I*4
CC               LSTDEL(K,I),K=1,..,5, I=1,2,..,MAXDEL        I*4
CC               LSTMXI(K,I),K=1,..,5, I=1,2,..,MAXMXI        I*4
CC               SLPLST(I),I=1,2,..,MAXSLP                    R*8
CC               SLPXXX(K,I),K=1,2,I=1,2,..MAXSLP             R*8
CC               IONO(K,I),K=1,2,3, I=1,2,..,MAXSLP           R*8
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  G.BEUTLER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  88/11/18 21:01
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1988     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 I     , K     , MXCDEL, MXCMXI, MXCSLP
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
CCC       IMPLICIT INTEGER*4 (I-N)
C
      REAL*8      SLPLST(MXCSLP),SLPXXX(2,MXCSLP),
     1            IONO(3,MXCSLP)
      INTEGER*4   LSTSLP(6,MXCSLP),LSTDEL(5,MXCDEL),LSTMXI(5,MXCMXI)
      CHARACTER*6 MXNSLP,MXNDEL,MXNMXI
C
      COMMON/MCMSLP/MXCSLP,MXNSLP
      COMMON/MCMDEL/MXCDEL,MXNDEL
      COMMON/MCMMXI/MXCMXI,MXNMXI
C
      DO 10 I=1,MXCSLP
        DO 5 K=1,6
          LSTSLP(K,I)=0
5       CONTINUE
        SLPLST(I)=0.D0
        SLPXXX(1,I)=0.D0
        SLPXXX(2,I)=0.D0
        IONO(1,I)=0.D0
        IONO(2,I)=0.D0
        IONO(3,I)=0.D0
10    CONTINUE
C
      DO 20 I=1,MXCDEL
        DO 20 K=1,5
          LSTDEL(K,I)=0
20    CONTINUE
C
      DO 30 I=1,MXCMXI
        DO 30 K=1,5
          LSTMXI(K,I)=0
30    CONTINUE
C
      RETURN
      END SUBROUTINE

      END MODULE
