      MODULE f_maxlr8
      CONTAINS

C*
      FUNCTION MAXLR8(NLIST,R8LIST,R8ITEM)
CC
CC NAME       :  MAXLR8
CC
CC PURPOSE    :  SEARCH GREATEST ITEM IN A LIST
CC
CC PARAMETERS :
CC         IN    NLIST  : NUMBER OF ITEMS IN LIST             I*4
CC               R8LIST : LIST TO BE SEARCHED                 R*8(*)
CC        OUT :  R8ITEM : GREATEST ITEM IN LIST               R*8
CC               MAXLR8 : POSITION OF ITEM IN LIST            I*4
CC
CC REMARKS    :  IF MORE THAN ONE GREATEST ITEM EXISTS,
CC               "IPOS" WILL BE THE POSITION OF THE FIRST ONE
CC
CC AUTHOR     :  T. SCHILDKNECHT
CC
CC
CC CREATED    :  29-APR-88
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1988     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
C
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 ILIST , MAXLR8, NLIST
C
CCC       IMPLICIT INTEGER*4(I-N)
      REAL*8    R8LIST(*),R8ITEM
C
C  LOOK FOR GREATEST ITEM
      R8ITEM=R8LIST(1)
      MAXLR8=1
      DO 10 ILIST=1,NLIST
        IF(R8LIST(ILIST).GT.R8ITEM) THEN
          R8ITEM=R8LIST(ILIST)
          MAXLR8=ILIST
        ENDIF
10    CONTINUE
C
      RETURN
      END FUNCTION

      END MODULE
