      MODULE s_MJDGPS
      CONTAINS

C*
      SUBROUTINE MJDGPS(TJUL,SECOND,NWEEK)
CC
CC NAME       :  MJDGPS
CC
CC PURPOSE    :  COMPUTE NUMBER OF SECONDS PAST MIDNIGHT OF LAST
CC               SATURDAY/SUNDAY AND GPS WEEK NUMBER OF CURRENT
CC               DATE GIVEN IN MODIFIED JULIAN DATE
CC
CC PARAMETERS :
CC         IN :  TJUL   : MODIFIED JULIAN DATE                     R*8
CC        OUT :  SECOND : NUMBER OF SECONDS PAST MIDNIGHT OF LAST  R*8
CC                        WEEKEND (SATURDAY/SUNDAY)
CC               NWEEK  : GPS WEEK NUMBER OF CURRENT WEEK          I*4
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  W. GURTNER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  86/11/10 10:23
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 NWEEK
C
      REAL*8    DELTAT, SECOND, TJUL
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
C
C  DAYS SINCE STARTING EPOCH OF GPS WEEKS (SUNDAY 06-JAN-80)
      DELTAT=TJUL-44244.D0
C  CURRENT GPS WEEK
      NWEEK=DINT(DELTAT/7.D0)
C  SECONDS PAST MIDNIGHT OF LAST WEEKEND
      SECOND=(DELTAT-(NWEEK)*7.D0)*86400.D0
C
      RETURN
      END SUBROUTINE

      END MODULE
