      MODULE s_SPROD
      CONTAINS

C*
      SUBROUTINE SPROD(X,Y,SCAL,R1,R2)
CC
CC NAME       :  SPROD
CC
CC PURPOSE    :  COMPUTATION OF THE SCALAR-PRODUCT OF TWO VECTORS
CC               X, AND Y IN 3-D EUCLIDEAN SPACE
CC
CC PARAMETERS :
CC         IN :  X(I),I=1,2,3: COMPONENTS OF VECTOR X         R*8
CC               Y(I),I=1,2,3: COMPONENTS OF VECTOR Y         R*8
CC        OUT :  SCAL   : SCALAR PRODUCT OF X AND Y           R*8
CC               R1,R2  : LENGTHS OF THE TWO VECTORS X AND Y  R*8
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  G.BEUTLER, M.ROTHACHER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  87/12/11 12:02
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      REAL*8    R1  , R2  , SCAL
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 X(3),Y(3)
      R1=DSQRT(X(1)**2+X(2)**2+X(3)**2)
      R2=DSQRT(Y(1)**2+Y(2)**2+Y(3)**2)
      SCAL=X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
      RETURN
      END SUBROUTINE

      END MODULE
