      MODULE s_UPPERC
      CONTAINS

C*
      SUBROUTINE UPPERC(STRING)
CC
CC NAME       :  UPPERC
CC
CC PURPOSE    :  CHECK FOR LOWERCASE CHARACTERS,
CC               CONVERT TO UPPERCASE
CC
CC PARAMETERS :
CC     IN/OUT :  STRING : STRING TO BE CHECKED               CH*(*)
CC
CC REMARKS    :  VALID FOR EBCDIC, ASCII, AND ASCII PR1ME
CC
CC AUTHOR     :  W. GURTNER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  88/10/31 15:06
CC
CC CHANGES    :  10-AUG-94 : MR: CALL EXITRC
CC               21-JUN-05 : MM: COMLFNUM.inc REMOVED, m_bern ADDED
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1988     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE m_bern
      USE s_exitrc
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 I     , ICH   , ICHARZ, IFIRST, ITYPE
C
      CHARACTER*(*) STRING
C
C
      DATA IFIRST/1/
C
C DETECT TYPE OF CHARACTER REPRESENTATION
C ---------------------------------------
      IF(IFIRST.EQ.1) THEN
        IFIRST=0
        ICHARZ=ICHAR('Z')
C
C EBCDIC
        IF(ICHARZ.EQ.233) THEN
          ITYPE=1
C
C ASCII
        ELSE IF(ICHARZ.EQ.90) THEN
          ITYPE=2
C
C ASCII (MSB SET, AS WITH PR1ME COMPUTER)
        ELSE IF(ICHARZ.EQ.218) THEN
          ITYPE=3
        ELSE
          WRITE(LFNERR,901)
901       FORMAT(/,' *** SR UPPERC: NON-STANDARD CHARACTER',
     1             ' REPRESENTATION',/)
          CALL EXITRC(2)
        ENDIF
      ENDIF
C
C CONVERSION TO UPPERCASE
C -----------------------
      DO 10 I=1,LEN(STRING)
        ICH=ICHAR(STRING(I:I))
C
        GOTO (100,200,300) ITYPE
C
C  EBCDIC
100     IF((129.LE.ICH.AND.ICH.LE.137).OR.
     2     (145.LE.ICH.AND.ICH.LE.153).OR.
     3     (162.LE.ICH.AND.ICH.LE.169)) STRING(I:I)=CHAR(ICH+64)
        GOTO 10
C
C  ASCII
200     IF(97.LE.ICH.AND.ICH.LE.122) STRING(I:I)=CHAR(ICH-32)
        GOTO 10
C
C  ASCII (MSB SET, AS WITH PR1ME COMPUTER)
300     IF(225.LE.ICH.AND.ICH.LE.250) STRING(I:I)=CHAR(ICH-32)
        GOTO 10
C
10    CONTINUE
C
      RETURN
      END SUBROUTINE

      END MODULE
