      MODULE s_VPROD
      CONTAINS

C*
      SUBROUTINE VPROD(X,Y,Z)
CC
CC NAME       :  VPROD
CC
CC PURPOSE    :  COMPUTATION OF THE VECTOR-PRODUCT Z OF TWO VECTORS
CC               X, AND Y IN 3-D EUCLIDEAN SPACE Z=X*Y
CC
CC PARAMETERS :
CC         IN :  X(I),I=1,2,3 COMPONENTS OF VECTOR X          R*8
CC               Y(I),I=1,2,3 COMPONENTS OF VECTOR Y          R*8
CC        OUT :  Z(I),I=1,2,3 COMPONENTS OF VECTOR Z=X*Y      R*8
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  G.BEUTLER, M.ROTHACHER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  87/11/30 08:11
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
CCC       IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 X(3),Y(3),Z(3)
      Z(1)=X(2)*Y(3)-X(3)*Y(2)
      Z(2)=X(3)*Y(1)-X(1)*Y(3)
      Z(3)=X(1)*Y(2)-X(2)*Y(1)
      RETURN
      END SUBROUTINE

      END MODULE
